 // IR remote control based on PIC12F1822 (Receiver code)
 // Written by: BENCHEROUDA Okba
 // electronnote@gmail.com
 // http://elecnote.blogspot.com/
 // Internal oscillator used @ 32MHz
 // Use at your own risk

 bit RC5, toggle;
 unsigned short i, address, command;

 unsigned short read_signal(){
   RC5 = 0;
   // Check if the received signal is RC5 protocol
   delay_us(445);
   if(!PORTA.F3)
     delay_us(889);
   else return;
   if(PORTA.F3)
     delay_us(889);
   else return;
   if(!PORTA.F3)
     delay_us(1778);
   else return;
   // Read signal data
   for(i = 0; i < 12; i++){
     if(!i){
       if (PORTA.F3) toggle = 0;
       else          toggle = 1;
       }
     else {
       if(i < 6){                   //Read address bits
         if (PORTA.F3)
           address &= ~(1 << (5 - i));  //Clear bit (5-i)
         else
           address |= (1 << (5 - i));   //Set bit (5-i)
         }
       else {                       //Read command bits
         if (PORTA.F3)
           command &= ~(1 << (11 - i)); //Clear bit (11-i)
         else
           command |= (1 << (11 - i));  //Set bit (11-i)
         }
       }
       delay_us(1778);
     }
   RC5 = 1;
   }
 void main() {
   OSCCON = 0xF0; // Internal oscillator 8MHz and PLL enabled (gives 32MHz)
   ANSELA = 0;    // All I/O pins are configured as digital
   ADCON0 = 0;    // Disable ADC module
   PORTA = 0;     // Initial value of port A bits
   TRISA = 8;     // Configure RA3 as input
   while(1){
     while(PORTA.F3);
     read_signal();
     if(RC5){     // If RC5 bit equal to one
       address &= 0x1F;
       command &= 0x3F;
       if((address == 0) && (command == 1))
         PORTA.F0 = ~PORTA.F0;
       if((address == 0) && (command == 2))
         PORTA.F1 = ~PORTA.F1;
       if((address == 0) && (command == 3))
         PORTA.F2 = ~PORTA.F2;
       if((address == 0) && (command == 4))
         PORTA.F4 = ~PORTA.F4;
       if((address == 0) && (command == 5))
         PORTA.F5 = ~PORTA.F5;
       }
     delay_ms(500);
     }
   }